## openl2tp-1.8.tar.gz

=== Makefile ===
# BEGIN CONFIGURABLE SETTINGS

# Compile-time features
L2TP_FEATURE_LAC_SUPPORT=	y
L2TP_FEATURE_LNS_SUPPORT=	y
L2TP_FEATURE_RPC_MANAGEMENT=	y
L2TP_FEATURE_LAIC_SUPPORT=	y
L2TP_FEATURE_LAOC_SUPPORT=	y
L2TP_FEATURE_LNIC_SUPPORT=	y
L2TP_FEATURE_LNOC_SUPPORT=	y
L2TP_FEATURE_LOCAL_CONF_FILE=	y
#L2TP_FEATURE_LOCAL_STAT_FILE=	y

# Define USE_DMALLOC to enable dmalloc memory debugging
# USE_DMALLOC=		y

# Define to include test code. This must be defined to run the
# regression tests
# L2TP_TEST=		y

# Define to compile in debug code. Also makes default trace flags
# enable all messages
# L2TP_DEBUG=		y

# Use asynchronous RPC requests where appropriate
# Affects only L2TP-PPP-IPPOOL interfaces, not management interfaces.
L2TP_USE_ASYNC_RPC=	y

# Build for UML environment?
# UML_TARGET=		y

# Location of shared libs. This is usually /usr/lib, but can be
# /usr/lib32 or /usr/lib64 on 64-bit multi-arch systems. On 64-bit
# systems which don't have 32-bit multi-arch libs installed, the
# standard says build with /usr/lib. But Fedora uses /usr/lib64. We
# try to handle these cases by deriving the CPU architecture
# name. Things are made more complicated by the fact that the CPU
# architecture is output by either uname -m or uname -p, depending on
# uname version. Override SYS_LIBDIR from the command line when
# necessary.
SYS_LIBDIR=/usr/lib
ifeq ($(CROSS_COMPILE),)
 ifeq ($(strip $(wildcard /etc/debian_version*)),)
  ifeq ($(shell uname -p),x86_64)
  SYS_LIBDIR=/usr/lib64
  else
   ifeq ($(shell uname -m),x86_64)
   SYS_LIBDIR=/usr/lib64
   endif
  endif
 endif
endif

# Points to pppd install.  By default, pppd headers are assumed to be
# in the pppd subdirectory of the compiler's default search path
# (e.g. /usr/include/pppd). but can be pointed to another directory if
# desired.
PPPD_VERSION=		2.4.5
# PPPD_INCDIR=		/usr/include/pppd
# PPPD_LIBDIR=		$(SYS_LIBDIR)/pppd/$(PPPD_VERSION)

# Points to readline install root. READLINE_DIR should have lib/ &
# include/ subdirs If not defined, readline is assumed to be installed
# in the standard places that the compiler looks.
READLINE_DIR=		

# For cross-compiling
CROSS_COMPILE=

# END CONFIGURABLE SETTINGS

AS		= $(CROSS_COMPILE)as
LD		= $(CROSS_COMPILE)ld
CC		= $(CROSS_COMPILE)gcc
AR		= $(CROSS_COMPILE)ar
NM		= $(CROSS_COMPILE)nm
STRIP		= $(CROSS_COMPILE)strip
INSTALL		= $(CROSS_COMPILE)install

ifneq ($(READLINE_DIR),)
READLINE_LDFLAGS=	-L $(READLINE_DIR)/lib
READLINE_CFLAGS=	-I $(READLINE_DIR)/include
endif

export PPPD_VERSION PPPD_SRCDIR PPPD_LIBDIR READLINE_LDFLAGS READLINE_CFLAGS
export CROSS_COMPILE AS LD CC AR NM STRIP OBJCOPY OBJDUMP INSTALL UML_TARGET
export DESTDIR SYS_LIBDIR

# Feature options are exported to sub-makes
export L2TP_FEATURE_LAC_SUPPORT
export L2TP_FEATURE_LNS_SUPPORT
export L2TP_FEATURE_RPC_MANAGEMENT
export L2TP_FEATURE_LAIC_SUPPORT
export L2TP_FEATURE_LAOC_SUPPORT
export L2TP_FEATURE_LNIC_SUPPORT
export L2TP_FEATURE_LNOC_SUPPORT
export L2TP_FEATURE_LOCAL_CONF_FILE
export L2TP_FEATURE_LOCAL_STAT_FILE

# Build pppd dir only if ppp version is earlier than 2.4.5 since the
# openl2tp plugins were integrated in ppp-2.4.5.
PPPD_SUBDIR=pppd
ifeq ($(PPPD_VERSION),2.4.5)
PPPD_SUBDIR=
endif

SUBDIRS=		usl cli plugins $(PPPD_SUBDIR) test doc

.PHONY:			$(SUBDIRS:%=subdir-%)

L2TP_RPC_STEM=		l2tp_rpc

RPC_FILES=		$(L2TP_RPC_STEM).h
ifeq ($(L2TP_FEATURE_RPC_MANAGEMENT),y)
RPC_FILES+=		$(L2TP_RPC_STEM)_server.c $(L2TP_RPC_STEM)_client.c $(L2TP_RPC_STEM)_xdr.c
endif

ifeq ($(L2TP_FEATURE_LOCAL_CONF_FILE),y)
PARSE_FILES=		l2tp_config_token.c l2tp_config_parse.c l2tp_config_parse.h
endif

L2TPD_SRCS.c=		l2tp_main.c l2tp_common.c l2tp_avp.c l2tp_packet.c \
			l2tp_network.c l2tp_tunnel.c l2tp_peer.c l2tp_transport.c \
			l2tp_session.c l2tp_ppp.c \
			l2tp_plugin.c l2tp_event.c l2tp_test.c md5.c
ifeq ($(L2TP_FEATURE_RPC_MANAGEMENT),y)
L2TPD_SRCS.c+=		l2tp_api.c
endif
ifeq ($(L2TP_FEATURE_LOCAL_STAT_FILE),y)
L2TPD_SRCS.c+=		l2tp_statusfile.c
endif

L2TPD_SRCS.h=		l2tp_api.h l2tp_avp.h l2tp_private.h md5.h

ifeq ($(L2TP_TEST),y)
CPPFLAGS.l2tptest=	-DL2TP_TEST
endif

L2TPCONFIG_SRCS.c=	l2tp_config.c

L2TPD_SRCS.o=		$(L2TPD_SRCS.c:%.c=%.o)
ifeq ($(L2TP_FEATURE_RPC_MANAGEMENT),y)
L2TPD_SRCS.o+=		$(L2TP_RPC_STEM)_server.o $(L2TP_RPC_STEM)_xdr.o
endif
L2TPCONFIG_SRCS.o=	$(L2TPCONFIG_SRCS.c:%.c=%.o) $(L2TP_RPC_STEM)_client.o $(L2TP_RPC_STEM)_xdr.o

L2TPD_SRCS.o+=		$(filter-out l2tp_config_parse.h, $(PARSE_FILES:%.c=%.o))

ifeq ($(USE_DMALLOC),y)
CPPFLAGS.dmalloc=	-DL2TP_DMALLOC
LIBS.dmalloc=		-ldmalloc
export USE_DMALLOC
endif

CPPFLAGS=		$(CPPFLAGS.l2tptest) $(CPPFLAGS-y)
CFLAGS=			-I. -Iusl -Icli -isystem include \
				-MMD -Wall -Werror -Wno-strict-aliasing \
				$(CPPFLAGS) $(CPPFLAGS.dmalloc) \
				-DSYS_LIBDIR=$(SYS_LIBDIR)
LDFLAGS.l2tpd=		-Wl,-E -L. -Lusl -lusl -ldl $(LIBS.dmalloc) -lc
LDFLAGS.l2tpconfig=	-Lcli -lcli -lreadline $(LIBS.dmalloc) $(READLINE_LDFLAGS) -lc

OPT_CFLAGS?=		-O

ifeq ($(L2TP_DEBUG),y)
CFLAGS.optimize=	-g
CFLAGS.optimize+=	-DDEBUG
else
CFLAGS.optimize=	$(OPT_CFLAGS)
endif
export CFLAGS.optimize

CFLAGS+=		$(CFLAGS.optimize)

ifeq ($(L2TP_USE_ASYNC_RPC),y)
CPPFLAGS+=		-DL2TP_ASYNC_RPC
endif

ifeq ($(L2TP_FEATURE_RPC_MANAGEMENT),y)
APP=			l2tpconfig
endif

RPCGEN=			rpcgen
RPCGENFLAGS=		-N -M -C -L

.PHONY:			all clean distclean install daemon app test

all:			generated-files daemon $(APP)

daemon:			generated-files $(SUBDIRS:%=subdir-%) openl2tpd

app:			generated-files l2tpconfig

test:			subdir-test
			$(MAKE) -C $@ $(MFLAGS) $@


.PHONY:			$(SUBDIRS:%=subdir-%)

$(SUBDIRS:%=subdir-%):	FORCE
			$(MAKE) -C $(@:subdir-%=%) $(MFLAGS) EXTRA_CFLAGS="$(CPPFLAGS)"

ifeq ($(L2TP_FEATURE_LOCAL_CONF_FILE),y)
# Config file parser
LEX=			flex
YACC=			bison
LDFLAGS.l2tpd+=		-lfl
%.c:	%.l
			$(LEX) -o$@ $<

%.h %.c: %.y
			$(YACC) -d -o l2tp_config_parse.c $<

l2tp_config_token.o:	l2tp_config_token.c
			$(CC) -I. -MMD -w $(CFLAGS.optimize) -c -DYY_NO_UNPUT $<

l2tp_config_parse.o:	l2tp_config_parse.c l2tp_config_parse.h
			$(CC) -I. -MMD -w $(CFLAGS.optimize) -c -DYY_NO_UNPUT $<
endif

# Compile without -Wall because rpcgen-generated code is full of warnings.
%_xdr.o:		%_xdr.c
			$(CC) -I. -MMD -w $(CFLAGS.optimize) -c $(CPPFLAGS) $<

%_client.o:		%_client.c
			$(CC) -I. -MMD -w $(CFLAGS.optimize) -c $(CPPFLAGS) $<

%_server.o:		%_server.c
			$(CC) -I. -MMD -w $(CFLAGS.optimize) -c $(CPPFLAGS) $<

%_xdr.c:		%.x
			-$(RM) $@
			$(RPCGEN) $(RPCGENFLAGS) -c -o $@ $<

%_server.c:		%.x
			-$(RM) $@ $@.tmp
			$(RPCGEN) $(RPCGENFLAGS) -m -o $@.tmp $<
			cat $@.tmp | sed -e 's/switch (rqstp->rq_proc) {/if (l2tp_api_rpc_check_request(transp) < 0) return; switch (rqstp->rq_proc) {/' > $@

%_client.c:		%.x
			-$(RM) $@
			$(RPCGEN) $(RPCGENFLAGS) -l -o $@ $<

%.h:			%.x
			-$(RM) $@
			$(RPCGEN) $(RPCGENFLAGS) -h -o $@ $<

.PHONY:			generated-files plugins clean distclean

generated-files:	$(RPC_FILES) $(PARSE_FILES) l2tp_options.h

clean:
			@for d in $(SUBDIRS); do $(MAKE) -C $$d $(MFLAGS) $@; if [ $$? -ne 0 ]; then exit 1; fi; done
			-$(MAKE) -C redhat $(MFLAGS) $@
			-$(RM) $(L2TPD_SRCS.o) $(L2TPCONFIG_SRCS.o) openl2tpd l2tpconfig $(RPC_FILES)
			-$(RM) l2tp_options.h l2tp_options.h.tmp
			-$(RM) l2tp_config_parse.c l2tp_config_parse.h l2tp_config_token.c
			-$(RM) $(wildcard *.d)
			-$(RM) $(wildcard l2tp_*rpc_*.tmp)

distclean:		clean
			-$(RM) TAGS

TAGS:
			@for d in $(SUBDIRS); do $(MAKE) -C $$d $(MFLAGS) $@; done
			etags $(wildcard *.c) $(wildcard *.h)

openl2tpd:		$(L2TPD_SRCS.o)
			$(CC) -o $@ $^ $(LDFLAGS.l2tpd)

l2tpconfig:		$(L2TPCONFIG_SRCS.o)
			$(CC) -o $@ $^ $(LDFLAGS.l2tpconfig)

%.o:	%.c
			$(CC) -c $(CFLAGS) $< -o $@

l2tp_options.h:	FORCE
	@rm -f $@.tmp
	@echo '/* This file is auto-generated. DO NOT EDIT. */' >> $@.tmp
	@echo '#ifndef L2TP_OPTIONS_H' >> $@.tmp
	@echo '#define L2TP_OPTIONS_H' >> $@.tmp
	@echo >> $@.tmp
ifeq ($(L2TP_FEATURE_LOCAL_CONF_FILE),y)
	@echo '#define L2TP_FEATURE_LOCAL_CONF_FILE' >> $@.tmp
endif
ifeq ($(L2TP_FEATURE_LOCAL_STAT_FILE),y)
	@echo '#define L2TP_FEATURE_LOCAL_STAT_FILE' >> $@.tmp
endif
ifeq ($(L2TP_FEATURE_LAC_SUPPORT),y)
	@echo '#define L2TP_FEATURE_LAC_SUPPORT' >> $@.tmp
endif
ifeq ($(L2TP_FEATURE_LNS_SUPPORT),y)
	@echo '#define L2TP_FEATURE_LNS_SUPPORT' >> $@.tmp
endif
ifeq ($(L2TP_FEATURE_LAIC_SUPPORT),y)
	@echo '#define L2TP_FEATURE_LAIC_SUPPORT' >> $@.tmp
endif
ifeq ($(L2TP_FEATURE_LAOC_SUPPORT),y)
	@echo '#define L2TP_FEATURE_LAOC_SUPPORT' >> $@.tmp
endif
ifeq ($(L2TP_FEATURE_LNIC_SUPPORT),y)
	@echo '#define L2TP_FEATURE_LNIC_SUPPORT' >> $@.tmp
endif
ifeq ($(L2TP_FEATURE_LNOC_SUPPORT),y)
	@echo '#define L2TP_FEATURE_LNOC_SUPPORT' >> $@.tmp
endif
ifeq ($(L2TP_FEATURE_RPC_MANAGEMENT),y)
	@echo '#define L2TP_FEATURE_RPC_MANAGEMENT' >> $@.tmp
endif
	@echo >> $@.tmp
	@echo '#endif' >> $@.tmp
	@if [ -e $@ ]; then \
		diff -q $@ $@.tmp > /dev/null ;\
		if [ $$? -ne 0 ]; then \
			mv $@.tmp $@ ;\
		fi ;\
	else \
		mv $@.tmp $@ ;\
	fi

.PHONY:			all install-all install-daemon install-app

install:		install-all

install-all:		all install-daemon install-app

install-daemon:
			@for d in $(filter-out usl,$(SUBDIRS)); do $(MAKE) -C $$d $(MFLAGS) EXTRA_CFLAGS="$(CPPFLAGS)" install; if [ $$? -ne 0 ]; then exit 1; fi; done
			$(INSTALL) -d $(DESTDIR)/usr/sbin
			$(INSTALL) openl2tpd $(DESTDIR)/usr/sbin

install-app:
			$(INSTALL) -d $(DESTDIR)/usr/bin
ifeq ($(L2TP_FEATURE_RPC_MANAGEMENT),y)
			$(INSTALL) l2tpconfig $(DESTDIR)/usr/bin
endif
			$(INSTALL) -d $(DESTDIR)$(SYS_LIBDIR)/openl2tp
			$(INSTALL) -m 0644 l2tp_rpc.x $(DESTDIR)$(SYS_LIBDIR)/openl2tp/l2tp_rpc.x
			$(INSTALL) -m 0644 l2tp_event.h $(DESTDIR)$(SYS_LIBDIR)/openl2tp/l2tp_event.h

FORCE:

huh:
	@set
	@echo $(_libdir)
	@echo $(LIBDIR)

sinclude		$(wildcard *.d) /dev/null

=== cli/Makefile ===
CLI_SRCS.c=		cli_lib.c cli_readline.c cli_util.c
CLI_SRCS.h=		cli_api.h cli_private.h
CLI_SRCS_TEST.c=	cli_test.c

CLI_SRCS.o=		$(CLI_SRCS.c:%.c=%.o)
CLI_SRCS_TEST.o=	$(CLI_SRCS_TEST.c:%.c=%.o)

LDFLAGS.cli_test=	-L.. -L. $(READLINE_LDFLAGS) -lcli -lusl -lreadline -lcurses -lc

CFLAGS=			$(CFLAGS.optimize) -MMD -Wall -Werror -I.. $(READLINE_CFLAGS)

.PHONY:			all test clean

all:			libcli.a

test:			libcli.a cli_test

libcli.a:		$(CLI_SRCS.o)
			$(AR) rus $@ $^

cli_test:		$(CLI_SRCS_TEST.o) libcli.a
			$(CC) -o $@ $(CLI_SRCS_TEST.o) $(LDFLAGS.cli_test)

clean:
	$(RM) $(CLI_SRCS.o) $(CLI_SRCS_TEST.o) libcli.a cli_test $(wildcard *.d)

distclean:
			$(RM) TAGS

%.o:	%.c
			$(CC) -c $(CFLAGS) $< -o $@

install:		all
#			$(INSTALL) -d $(DESTDIR)$(SYS_LIBDIR)
#			$(INSTALL) libcli.a $(DESTDIR)$(SYS_LIBDIR)

TAGS:			$(CLI_SRCS.c) $(CLI_SRCS.h)
			etags $^

include $(wildcard *.d /dev/null)

=== plugins/Makefile ===
CFLAGS	:= $(CFLAGS.optimize) -MMD -Wall \
	-isystem ../include \
	-I. -I.. -I../usl -fPIC $(EXTRA_CFLAGS)
LDFLAGS	:= -shared

PLUGINS.c:=	ppp_unix.c ppp_null.c ipsec.c event_sock.c

ifneq (,$(findstring -DL2TP_TEST,$(CFLAGS)))
PLUGINS.c+=	ppp_test.c
endif

PLUGINS.so=	$(PLUGINS.c:%.c=%.so)

SRC.generated=

.PHONY:		all clean install TAGS generated-files

all:		generated-files $(PLUGINS.so)

clean:
		$(RM) $(PLUGINS.so) $(wildcard *.o) $(wildcard *.d) $(SRC.generated)

%.so: %.c
		$(CC) -o $@ $(LDFLAGS) $(CFLAGS) $<

install:	all
		$(INSTALL) -d $(DESTDIR)$(SYS_LIBDIR)/openl2tp
		$(INSTALL) $(PLUGINS.so) $(DESTDIR)$(SYS_LIBDIR)/openl2tp
		$(INSTALL) -m 0644 event_sock.h $(DESTDIR)$(SYS_LIBDIR)/openl2tp


generated-files:	$(SRC.generated)

include $(wildcard *.d) /dev/null

=== pppd/Makefile ===
# BEGIN CONFIGURABLE SETTINGS

ifdef PPPD_INCDIR
CFLAGS.pppd=	-I$(PPPD_INCDIR)
endif
ifndef PPPD_LIBDIR
PPPD_LIBDIR=	$(SYS_LIBDIR)/pppd/$(PPPD_VERSION)
endif

# END CONFIGURABLE SETTINGS

CFLAGS	+= $(CFLAGS.optimize) -I../include -I.. \
	$(CFLAGS.pppd) -DHAVE_MULTILINK -fPIC
LDFLAGS	+= -shared

PLUGINS=	pppol2tp.so
PLUGINS+=	openl2tp.so

all:	$(PLUGINS)

pppol2tp.so: pppol2tp.c
	$(CC) -o $@ $(LDFLAGS) $(CFLAGS) -D_linux_=1 $^

openl2tp.so: openl2tp.c
	$(CC) -o $@ $(LDFLAGS) $(CFLAGS) -D_linux_=1 $^

install: pppol2tp.so
	$(INSTALL) -d $(DESTDIR)$(PPPD_LIBDIR)
	$(INSTALL) pppol2tp.so $(DESTDIR)$(PPPD_LIBDIR)
	$(INSTALL) openl2tp.so $(DESTDIR)$(PPPD_LIBDIR)

clean:
	-rm -rf *.o *.so *.d

=== redhat/Makefile ===
# Override one or more of the following to build RPM source and binary packages
ARCH=	i686
VER=	1.8
REL=	1
PPPVER=	2.4.5
TARGZ=	/tmp/openl2tp-$(VER).tar.gz
SPEC=	openl2tp.spec
AUTHOR=	$(shell whoami)
DATE=	$(shell date '+%a %b %d %Y')
REDHAT=	/usr/src/redhat

.PHONY:	spec rpm

all:	spec rpm

clean:
	-$(RM) $(wildcard *.rpm) openl2tp-$(VER)-$(REL).spec

spec:
	@if [ ! -e $(TARGZ) ]; then \
		echo "$(TARGZ) not found. Aborting." ;\
		echo "Use make TARGZ=<file> to point to the OpenL2TP release tarball" ;\
	fi
	cp $(SPEC) openl2tp-1.spec
	cat openl2tp-1.spec | sed -e 's/%%VER%%/${VER}/g' > openl2tp-2.spec
	mv -f openl2tp-2.spec openl2tp-1.spec
	cat openl2tp-1.spec | sed -e 's/%%REL%%/${REL}/g' > openl2tp-2.spec
	mv -f openl2tp-2.spec openl2tp-1.spec
	cat openl2tp-1.spec | sed -e 's/%%PPPVER%%/${PPPVER}/g' > openl2tp-2.spec
	mv -f openl2tp-2.spec openl2tp-1.spec
	cat openl2tp-1.spec | sed -e 's/%%AUTHOR%%/$(AUTHOR)/g' > openl2tp-2.spec
	mv -f openl2tp-2.spec openl2tp-1.spec
	cat openl2tp-1.spec | sed -e 's/%%DATE%%/$(DATE)/g' > openl2tp-2.spec
	mv -f openl2tp-2.spec openl2tp-1.spec
	mv -f openl2tp-1.spec openl2tp-$(VER)-$(REL).spec

rpm:
	cp openl2tp-$(VER)-$(REL).spec $(REDHAT)/SPECS/openl2tp.spec
#	cp $(wildcard openl2tp-*.patch) $(REDHAT)/SOURCES
	cp $(TARGZ) $(REDHAT)/SOURCES
	cd $(REDHAT)/SPECS; rpmbuild -ba --target=$(ARCH)-linux openl2tp.spec
	cp -v $(REDHAT)/RPMS/$(ARCH)/openl2tp*-$(VER)*.rpm .
	cp -v $(REDHAT)/SRPMS/openl2tp*-$(VER)*.rpm .

=== usl/Makefile ===
USL_SRCS.c=		usl_fd.c usl_misc.c usl_pid.c usl_signal.c \
			usl_timer.c usl_fsm.c
USL_SRCS.h=		usl_fsm.h usl.h usl_list.h
USL_SRCS_TEST.c=	usl_test.c

USL_SRCS.o=		$(USL_SRCS.c:%.c=%.o)
USL_SRCS_TEST.o=	$(USL_SRCS_TEST.c:%.c=%.o)

LDFLAGS.usl_test=	-L. -lc

ifeq ($(USE_DMALLOC),y)
CPPFLAGS.dmalloc=	-DUSL_DMALLOC
LIBS.dmalloc=		-ldmalloc
endif

CPPFLAGS+=		$(CFLAGS.optimize) -g
CFLAGS=			-I. -MMD -Wall -Werror -Wno-strict-aliasing $(CPPFLAGS) $(CPPFLAGS.dmalloc)

.PHONY:			all test clean

all:			libusl.a

test:			libusl.a usl_test

libusl.a:		$(USL_SRCS.o)
			$(AR) rus $@ $^

usl_test:		$(USL_SRCS_TEST.o) libusl.a
			$(CC) -o $@ $(USL_SRCS_TEST.o) $(LDFLAGS.usl_test)

clean:
			-$(RM) $(USL_SRCS.o) $(USL_SRCS_TEST.o) libusl.a usl_test $(wildcard *.d)

distclean:
			-$(RM) $(wildcard *~)

%.o:	%.c
			$(CC) -c $(CFLAGS) $< -o $@

install:		all
			$(INSTALL) -d $(DESTDIR)$(SYS_LIBDIR)
			$(INSTALL) libusl.a $(DESTDIR)$(SYS_LIBDIR)

checkin:		clean
			ci -u -q Makefile $(USL_SRCS.c) $(USL_SRCS.h) $(USL_SRCS_TEST.c)

TAGS:			$(USL_SRCS.c) $(USL_SRCS.h)
			etags $^

include $(wildcard *.d /dev/null)

=== debian/changelog ===
openl2tp (1.8-1) unstable; urgency=low

  * Built from upstream version.

 -- James Chapman <jchapman@openl2tp.org>  Mon, 22 Nov 2010 12:27:19 +0000

=== debian/control ===
Source: openl2tp
Section: net
Priority: optional
Maintainer: James Chapman <jchapman@openl2tp.org>
Build-Depends: debhelper (>= 5), ppp-dev (>= 2.4.4), libreadline-dev, flex, bison, linux-libc-dev (>= 2.6.23), dpatch
Standards-Version: 3.7.2

Package: openl2tp
Architecture: any
Depends: ${shlibs:Depends}, ppp (>= 2.4.4), portmap, libreadline5 | libreadline6
Description: A feature-rich L2TP client/server for VPN use
 OpenL2TP is a complete implementation of RFC2661 - Layer Two Tunneling
 Protocol Version 2, able to operate as both a server and a client. It
 is ideal for use as an enterprise L2TP VPN server, supporting more
 than 100 simultaneous connected users. It may also be used as a client
 on a home PC or roadwarrior laptop. L2TP/IPSec is supported using
 OpenSWAN or Racoon.
 .
 OpenL2TP has been designed and implemented specifically for Linux. It
 consists of
 .
  - a daemon, openl2tpd, handling the L2TP control protocol exchanges
   for all tunnels and sessions
 .
  - a plugin for pppd to allow its PPP connections to run over L2TP
   sessions
 .
  - a Linux kernel driver for efficient datapath (integrated into the
   standard kernel from 2.6.23)
 .
  - a command line application, l2tpconfig, for management.

Package: openl2tp-dev
Section: devel
Architecture: all
Priority: extra
Depends: openl2tp, ppp-dev
Description: This package contains support files for building plugins for OpenL2TP,
 or applications that use the OpenL2TP APIs.

Package: openl2tp-ppp
Section: net
Architecture: any
Priority: optional
Depends: openl2tp
Description: This package contains PPP plugins. It is required only if your ppp
 package does not contain the L2TP plugin. Most ppp packages should include the
 L2TP plugins from ppp-2.4.5.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1


ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	OPT_CFLAGS = -O0
else
	OPT_CFLAGS = -O2
endif

export OPT_CFLAGS

PPPD_VERSION=`cat /usr/include/pppd/patchlevel.h | grep VERSION | sed -e 's/\t/ /g' -e 's/\ \ / /g' -e 's/\"//g' | cut -d" " -f3`

configure: configure-stamp
configure-stamp:
	dh_testdir
	# Add here commands to configure the package.
	dpatch apply-all

	touch configure-stamp


build: build-stamp

build-stamp: configure-stamp 
	dh_testdir

	# Add here commands to compile the package.
	$(MAKE) PPPD_VERSION=$(PPPD_VERSION)
	#docbook-to-man debian/openl2tp.sgml > openl2tp.1

	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp

	# Add here commands to clean up after the build process.
	$(MAKE) clean
	$(MAKE) distclean

	dh_clean  --exclude ./debian.orig

install: build
	dh_testdir
	dh_testroot
	dh_clean -k  --exclude ./debian.orig
	dh_installdirs

	# Add here commands to install the package into debian/openl2tp.
	$(MAKE) PPPD_VERSION=$(PPPD_VERSION) \
		DESTDIR=$(CURDIR)/debian/openl2tp install

	# Move some files to openl2tp-dev
	if [ -d $(CURDIR)/debian/openl2tp/usr/lib/openl2tp ]; then \
		mkdir -p $(CURDIR)/debian/openl2tp-dev/usr/lib/openl2tp ;\
		mv -f $(CURDIR)/debian/openl2tp/usr/lib/openl2tp/*.[hx] $(CURDIR)/debian/openl2tp-dev/usr/lib/openl2tp/ ;\
	fi
	-mkdir -p $(CURDIR)/debian/openl2tp-dev/usr/share/man
	mv -f $(CURDIR)/debian/openl2tp/usr/share/man/man4 $(CURDIR)/debian/openl2tp-dev/usr/share/man/

	# Move some files to openl2tp-ppp
	-mkdir -p $(CURDIR)/debian/openl2tp-ppp
	if [ -d $(CURDIR)/debian/openl2tp/usr/lib/pppd ]; then \
		mkdir -p $(CURDIR)/debian/openl2tp-ppp/usr/lib ;\
		mv -f $(CURDIR)/debian/openl2tp/usr/lib/pppd $(CURDIR)/debian/openl2tp-ppp/usr/lib ;\
	fi

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs CHANGES
	dh_installdocs
	dh_installexamples
#	dh_installmenu
#	dh_installdebconf	
#	dh_installlogrotate	
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
	dh_installinit
#	dh_installcron
#	dh_installinfo
	dh_installman
	dh_link
	dh_strip
	dh_compress 
	dh_fixperms
#	dh_perl
#	dh_python
	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure
